'use strict'

exports.__esModule = true
exports.Box = void 0

var React = /*#__PURE__*/ _interopRequireWildcard(
  /*#__PURE__*/ require('react')
)

var _clsx = /*#__PURE__*/ _interopRequireDefault(/*#__PURE__*/ require('clsx'))

var _Layout = /*#__PURE__*/ require('./Layout')

function _interopRequireDefault(obj) {
  return obj && obj.__esModule ? obj : {default: obj}
}

function _getRequireWildcardCache() {
  if (typeof WeakMap !== 'function') return null
  var cache = new WeakMap()
  _getRequireWildcardCache = function () {
    return cache
  }
  return cache
}

function _interopRequireWildcard(obj) {
  if (obj && obj.__esModule) {
    return obj
  }
  if (obj === null || (typeof obj !== 'object' && typeof obj !== 'function')) {
    return {default: obj}
  }
  var cache = _getRequireWildcardCache()
  if (cache && cache.has(obj)) {
    return cache.get(obj)
  }
  var newObj = {}
  var hasPropertyDescriptor =
    Object.defineProperty && Object.getOwnPropertyDescriptor
  for (var key in obj) {
    if (Object.prototype.hasOwnProperty.call(obj, key)) {
      var desc = hasPropertyDescriptor
        ? Object.getOwnPropertyDescriptor(obj, key)
        : null
      if (desc && (desc.get || desc.set)) {
        Object.defineProperty(newObj, key, desc)
      } else {
        newObj[key] = obj[key]
      }
    }
  }
  newObj.default = obj
  if (cache) {
    cache.set(obj, newObj)
  }
  return newObj
}

const __reactCreateElement__ = React.createElement
const Box = /*#__PURE__*/ React.forwardRef(
  (
    {
      as: As = 'div',
      className,
      display,
      position,
      width,
      height,
      size,
      pad,
      bg,
      elevation,
      radius,
      ...props
    },
    ref
  ) => {
    const prop = (0, _Layout.useLayout)().mq.prop
    return /*#__PURE__*/ __reactCreateElement__(As, {
      ref: ref,
      className: (0, _clsx.default)(
        className,
        prop(frameStyle, display),
        prop(frameStyle, position),
        prop(widthStyle, width),
        prop(heightStyle, height),
        prop(sizeStyle, size),
        prop(padStyle, pad),
        prop(bgStyle, bg),
        prop(elevationStyle, elevation),
        prop(radiusStyle, radius)
      ),
      ...props,
    })
  }
)
exports.Box = Box
const d = 'display'
const p = 'position'
const frameStyle = {
  flex: `${d}:flex;`,
  inlineFlex: `${d}:inline-flex;`,
  block: `display:block;`,
  inlineBlock: `${d}:inline-block;`,
  inline: `${d}:inline;`,
  none: `${d}:none;`,
  relative: `${p}:relative;`,
  absolute: `${p}:absolute;`,
  sticky: `${p}:sticky;`,
  fixed: `${p}:fixed;`,
}

const widthStyle = (width) => ({
  width,
})

const heightStyle = (height) => ({
  height,
})

const sizeStyle = (size) => ({
  width: size,
  height: size,
})

const padStyle = (padProp) => ({pad}) =>
  Array.isArray(padProp)
    ? {
        padding: padProp.map((k) => pad[k]).join(' '),
      }
    : `padding:${pad[padProp]};` // @ts-ignore

const bgStyle = (bg) => ({color}) => `background:${color[bg]};` // @ts-ignore

const elevationStyle = (elevationProp) => ({elevation}) =>
  `box-shadow:${elevation[elevationProp]};` // @ts-ignore

const radiusStyle = (radiusProp) => ({radius}) =>
  Array.isArray(radiusProp)
    ? {
        borderRadius: radiusProp.map((k) => radius[k]).join(' '),
      }
    : `border-radius:${radius[radiusProp]};`
