'use strict'

exports.__esModule = true
exports.flexDirection = exports.alignContent = exports.justifyContent = exports.justifyItems = exports.justifySelf = exports.alignSelf = exports.alignItems = void 0
const ai = 'align-items'
const alignItems = {
  start: `${ai}:flex-start;`,
  center: `${ai}:center;`,
  end: `${ai}:flex-end;`,
  baseline: `${ai}:baseline;`,
  stretch: `${ai}:stretch;`,
}
exports.alignItems = alignItems
const aiEntries = /*#__PURE__*/ Object.entries(alignItems)

const replaceReducer = (from, to) => (current, [key, value]) => {
  current[key] = value.replace(from, to)
  return current
}

const alignSelf = /*#__PURE__*/ aiEntries.reduce(
  /*#__PURE__*/ replaceReducer('items', 'self'),
  {}
)
exports.alignSelf = alignSelf
const justifySelf = /*#__PURE__*/ aiEntries.reduce(
  /*#__PURE__*/ replaceReducer(ai, 'justify-self'),
  {}
)
exports.justifySelf = justifySelf
const justifyItems = /*#__PURE__*/ aiEntries.reduce(
  /*#__PURE__*/ replaceReducer('align', 'justify'),
  {}
)
exports.justifyItems = justifyItems
const jc = 'justify-content'
const justifyContent = {
  start: `${jc}:flex-start;`,
  center: `${jc}:center;`,
  end: `${jc}:flex-end;`,
  around: `${jc}:space-around;`,
  between: `${jc}:space-between;`,
  evenly: `${jc}:space-evenly;`,
  stretch: `${jc}:stretch;`,
}
exports.justifyContent = justifyContent
const alignContent = /*#__PURE__*/ Object.entries(justifyContent).reduce(
  /*#__PURE__*/ replaceReducer('justify', 'align'),
  {}
)
exports.alignContent = alignContent
const fd = 'flex-direction'
const flexDirection = {
  row: `${fd}:row;`,
  reversedRow: `${fd}:row-reverse;`,
  column: `${fd}:column;`,
  reversedColumn: `${fd}:column-reverse;`,
}
exports.flexDirection = flexDirection
