import * as React from 'react'
const __reactCreateElement__ = React.createElement
import clsx from 'clsx'
import {useLayout} from './Layout'
export const Box = /*#__PURE__*/ React.forwardRef(
  (
    {
      as: As = 'div',
      className,
      display,
      position,
      width,
      height,
      size,
      pad,
      bg,
      elevation,
      radius,
      ...props
    },
    ref
  ) => {
    const prop = useLayout().mq.prop
    return /*#__PURE__*/ __reactCreateElement__(As, {
      ref: ref,
      className: clsx(
        className,
        prop(frameStyle, display),
        prop(frameStyle, position),
        prop(widthStyle, width),
        prop(heightStyle, height),
        prop(sizeStyle, size),
        prop(padStyle, pad),
        prop(bgStyle, bg),
        prop(elevationStyle, elevation),
        prop(radiusStyle, radius)
      ),
      ...props,
    })
  }
)
const d = 'display'
const p = 'position'
const frameStyle = {
  flex: `${d}:flex;`,
  inlineFlex: `${d}:inline-flex;`,
  block: `display:block;`,
  inlineBlock: `${d}:inline-block;`,
  inline: `${d}:inline;`,
  none: `${d}:none;`,
  relative: `${p}:relative;`,
  absolute: `${p}:absolute;`,
  sticky: `${p}:sticky;`,
  fixed: `${p}:fixed;`,
}

const widthStyle = (width) => ({
  width,
})

const heightStyle = (height) => ({
  height,
})

const sizeStyle = (size) => ({
  width: size,
  height: size,
})

const padStyle = (padProp) => ({pad}) =>
  Array.isArray(padProp)
    ? {
        padding: padProp.map((k) => pad[k]).join(' '),
      }
    : `padding:${pad[padProp]};` // @ts-ignore

const bgStyle = (bg) => ({color}) => `background:${color[bg]};` // @ts-ignore

const elevationStyle = (elevationProp) => ({elevation}) =>
  `box-shadow:${elevation[elevationProp]};` // @ts-ignore

const radiusStyle = (radiusProp) => ({radius}) =>
  Array.isArray(radiusProp)
    ? {
        borderRadius: radiusProp.map((k) => radius[k]).join(' '),
      }
    : `border-radius:${radius[radiusProp]};`
