const ai = 'align-items'
export const alignItems = {
  start: `${ai}:flex-start;`,
  center: `${ai}:center;`,
  end: `${ai}:flex-end;`,
  baseline: `${ai}:baseline;`,
  stretch: `${ai}:stretch;`,
}
const aiEntries = /*#__PURE__*/ Object.entries(alignItems)

const replaceReducer = (from, to) => (current, [key, value]) => {
  current[key] = value.replace(from, to)
  return current
}

export const alignSelf = /*#__PURE__*/ aiEntries.reduce(
  /*#__PURE__*/ replaceReducer('items', 'self'),
  {}
)
export const justifySelf = /*#__PURE__*/ aiEntries.reduce(
  /*#__PURE__*/ replaceReducer(ai, 'justify-self'),
  {}
)
export const justifyItems = /*#__PURE__*/ aiEntries.reduce(
  /*#__PURE__*/ replaceReducer('align', 'justify'),
  {}
)
const jc = 'justify-content'
export const justifyContent = {
  start: `${jc}:flex-start;`,
  center: `${jc}:center;`,
  end: `${jc}:flex-end;`,
  around: `${jc}:space-around;`,
  between: `${jc}:space-between;`,
  evenly: `${jc}:space-evenly;`,
  stretch: `${jc}:stretch;`,
}
export const alignContent = /*#__PURE__*/ Object.entries(justifyContent).reduce(
  /*#__PURE__*/ replaceReducer('justify', 'align'),
  {}
)
const fd = 'flex-direction'
export const flexDirection = {
  row: `${fd}:row;`,
  reversedRow: `${fd}:row-reverse;`,
  column: `${fd}:column;`,
  reversedColumn: `${fd}:column-reverse;`,
}
